//+------------------------------------------------------------------+
//|                                                   Big Dog 10.mq4 |
//|                      Copyright  2011, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2011, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
#property show_inputs
extern int MaxRisk=2;
extern int TakeProfit=100;
extern int StopLoss=100;
extern int HourA=7;
extern int HourB=9;
extern int HourC=19;


int
   tic,
   i, 
   FLAG,
   KVADRAT,
   GRAN;
   
    
double
//   vline_1,
//   vline_2,
//   hline_1,
//   hline_2,
   MAX,
   MIN, 
   Lot;  

//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//----
 
 
if(Hour()==HourA && Minute()==0 && Seconds()==0)
  {
   ObjectsDeleteAll(0,-1); 
   ObjectCreate("vline_1",OBJ_VLINE,0,TimeCurrent(),0);
  }
  
if(Hour()==HourB && Minute()==0 && Seconds()==0)
  {  
   ObjectCreate("vline_2",OBJ_VLINE,0,TimeCurrent(),0);
   GRAN=1;
  }
  
if(GRAN==1)
  {
  MAX=High[0];
  MIN=Low[0];
  for(i=0;i<(HourB-HourA+1);i++)
     {
     if(High[i]>MAX)
       MAX=High[i];
     if(Low[i]<MIN)
       MIN=Low[i];
     }
  ObjectCreate("hline_1",OBJ_HLINE,0,0,MAX); 
  ObjectCreate("hline_2",OBJ_HLINE,0,0,MIN);
  GRAN=0;
  KVADRAT=1;
  }
  
if(KVADRAT==1)
  {
  double Lot=GetLot(MaxRisk);
  NewOrder(OP_BUYSTOP, Lot, TakeProfit, StopLoss);
  NewOrder(OP_SELLSTOP, Lot, TakeProfit, StopLoss);
  KVADRAT=0;
  }
  
if(Hour()==HourC && Minute()==0 && Seconds()==0)
   yDeleteOrder();
  
return(0);
 }
//----------------------------------------------------------------------
//----------------------   -----------------------------
//----------------------------------------------------------------------  


//+---------  ---------------------------------------+
double GetLot(int Risk)
{
 double Free=AccountFreeMargin();
 double One_Lot=MarketInfo(Symbol(),MODE_MARGINREQUIRED);
 double Min_Lot=MarketInfo(Symbol(),MODE_MINLOT);
 double Max_Lot=MarketInfo(Symbol(),MODE_MAXLOT);
 double Step=MarketInfo(Symbol(),MODE_LOTSTEP);
 double Lot=MathFloor(Free*Risk/100/One_Lot/Step)*Step;
 if(Lot<Min_Lot)Lot=Min_Lot;
 if(Lot>Max_Lot)Lot=Max_Lot;
 if(Lot*One_Lot>Free)return(0.0);
 return(Lot);
}

//+----------  -----------------------------------+
int NewOrder(int Cmd,double Lot,int TaPr,int StLo)
{
 double TP=0;// 
 double SL=0;// 
 double PR=0;// 
 while(!IsTradeAllowed())Sleep(100);
 if(TaPr<MarketInfo(Symbol(),MODE_STOPLEVEL))  
    TaPr=MarketInfo(Symbol(),MODE_STOPLEVEL);
 if(StLo<MarketInfo(Symbol(),MODE_STOPLEVEL))  
    StLo=MarketInfo(Symbol(),MODE_STOPLEVEL);
 if(Cmd==OP_BUY)
   {
    PR=NormalizeDouble(Ask, Digits);
    if(TaPr>0)TP=NormalizeDouble(Ask,Digits)+NormalizeDouble(TaPr*Point,Digits);
    if(StLo>0)SL=NormalizeDouble(Bid,Digits)-NormalizeDouble(StLo*Point,Digits);
   }
 if(Cmd==OP_SELL)
   {
    PR=NormalizeDouble(Bid, Digits);
    if(TaPr>0)TP=NormalizeDouble(Bid,Digits)-NormalizeDouble(TaPr*Point,Digits);
    if(StLo>0)  SL=NormalizeDouble(Ask,Digits)+NormalizeDouble(StLo*Point,Digits);
   }
 Print("TaPr=",TaPr," StLo=",StLo," StopLevel=",MarketInfo(Symbol(),MODE_STOPLEVEL));
 tic=OrderSend(Symbol(),Cmd,Lot,PR,3,SL,TP,"",0,0,CLR_NONE);
 if(tic<0)Print("  :",GetLastError()); Print("Cmd-",Cmd," Lot=",Lot," PR=",PR," SL=",SL," TP=",TP);
return(tic);
}

//+-----------   ----------------------------------+
int yDeleteOrder()
{
   for(int i=1; i<=OrdersTotal(); i++)
      {
         if(OrderSelect(i-1,SELECT_BY_POS)==true)
            {
               if(OrderType()==OP_SELLSTOP || OrderType()==OP_BUYSTOP)
                     OrderDelete(OrderTicket());
            }
         else
            Print("OrderSelect()   - ",GetLastError());
      }
   return(0);
} 
 
 
 
 
 
 
 
 
 
 
 
 
 
   
//----
  
//+------------------------------------------------------------------+